# -*- coding: utf-8 -*-
# https://github.com/Kodi-vStream/venom-xbmc-addons
#

from Plugins.Extensions.IPTVPlayer.libs.vstream.lib.comaddon import VSlog
from Plugins.Extensions.IPTVPlayer.libs.vstream.lib.gui.gui import cGui
from Plugins.Extensions.IPTVPlayer.tools.iptvtools import (GetCacheSubDir,
                                                           printDBG)


class cPlayer():
    def __init__(self, *args):
        VSlog('player initialized')

    def clearPlayList(self):
        return ''

    def __getPlayList(self):
        return ''

    def addItemToPlaylist(self, oGuiElement):
        oGui = cGui()
        VSlog('addItemToPlaylist')
        oListItem = oGui.createListItem(oGuiElement)
        self.__addItemToPlaylist(oGuiElement, oListItem)

    def __addItemToPlaylist(self, oGuiElement, oListItem):
        printDBG('addKodiWrite0001:')
        sPluginPath = 'Kodi'
        sId = oGuiElement.getSiteName()
        sLabel = oGuiElement.getTitle()
        sFunction = 'play'
        sIcon = oGuiElement.getIcon()

        sMediaUrl = oGuiElement.getMediaUrl()
        sSiteUrl = oGuiElement.getSiteUrl()
        printDBG(f'sMediaUrl:{sMediaUrl}')

    def MyPath(self):
        return GetCacheSubDir('Kodi')

    def AddSubtitles(self, files):
        return ''

    def run(self, oGuiElement, sTitle, sUrl):
        return ''

    def startPlayer(self, window=False):
        return ''

    def onPlayBackEnded(self):
        return ''

    def onPlayBackStopped(self):
        return ''

    def onPlayBackStarted(self):
        return ''

    def __getWatchlist(self, sAction):
        return ''

    def __getPlayerType(self):
        return False

    def enable_addon(self, addon):
        return ''
